# swagger_client

SwaggerClient - the Ruby gem for the DiscoverSnoop

API for DiscoverSnoop Service

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.9.240913
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.ruby.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build swagger_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./swagger_client-1.0.0.gem
```
(for development, run `gem install --dev ./swagger_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'swagger_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'swagger_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'swagger_client'
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::AlertsApi.new
id = 'id_example' # String | ID of the alert to edit ; if adding a new one leave blank
alertname = 'alertname_example' # String | Name of the alert
activated = true # BOOLEAN | Should the alert be activated or not
type = 56 # Integer | Alert type (1= New content for website, 2=New perfirming contents)
channel = 56 # Integer | 1 for email, 2 for Slack, 3 for Google Chat
recipient = 'recipient_example' # String | Email address of recipient or webhook for Slack/Gchat
opts = { 
  param1: 'param1_example', # String | Parameter 1 (meaning changes with alert type)
  param2: 'param2_example', # String | Parameter 2 (meaning changes with alert type)
  param3: 'param3_example', # String | Parameter 3 (meaning changes with alert type)
  param4: 'param4_example', # String | Parameter 4 (meaning changes with alert type)
  param5: 'param5_example' # String | Parameter 5 (meaning changes with alert type)
}

begin
  #Edit or insert new alert
  result = api_instance.alerts_change_get(id, alertname, activated, type, channel, recipient, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AlertsApi->alerts_change_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::AlertsApi.new
id = 'id_example' # String | alert id to delete


begin
  #Permanently delete the alert
  result = api_instance.alerts_delete_get(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AlertsApi->alerts_delete_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::AlertsApi.new

begin
  #Get alerts for user account
  result = api_instance.alerts_get
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AlertsApi->alerts_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
opts = { 
  name: 'name_example', # String | Name of the fav.
  action: 'action_example', # String | Action to be opened.
  parameters: 'parameters_example' # String | Action's parameters encoded in JSON.
}

begin
  #Create a new fav
  result = api_instance.favs_add_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_add_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
opts = { 
  id: 'id_example' # String | ID of the fav to delete.
}

begin
  #Permanently delete the fav
  result = api_instance.favs_delete_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_delete_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
opts = { 
  id: 'id_example' # String | ID of the requested fav. ignore or set to 0 to get the full favs list
}

begin
  #Get favorites
  result = api_instance.favs_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
id = 'id_example' # String | ID of the fav that should be edited
opts = { 
  name: 'name_example', # String | Name of the fav.
  action: 'action_example', # String | Action to be opened.
  parameters: 'parameters_example', # String | Action's parameters encoded in JSON.
  scheduled: 56, # Integer | 0 if not scheduled, else x in hours
  scheduledto: 'scheduledto_example' # String | email address of the recipient of this report
}

begin
  #Update the fav
  result = api_instance.favs_update_get(id, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_update_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::HistoricalApi.new
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  from_date: 'from_date_example', # String | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  to_date: 'to_date_example', # String | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  keyword_filter: 'keyword_filter_example', # String | Filter answers to cateogry names containing a particular keyword
  lines: 50, # Integer | Get X results (max in one request is 10K please use offset paginated results if you need more)
  offset: 0 # Integer | Get paginated results from X offset
}

begin
  #Get historical stats for categories
  result = api_instance.categories_get(country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling HistoricalApi->categories_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::HistoricalApi.new
id = 'id_example' # String | category id
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  from_date: 'from_date_example', # String | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  to_date: 'to_date_example' # String | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
}

begin
  #Get history for category ID
  result = api_instance.category_get(id, country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling HistoricalApi->category_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::HistoricalApi.new
domain = 'domain_example' # String | domain name (no subdomain allowed)
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  from_date: 'from_date_example', # String | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  to_date: 'to_date_example' # String | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
}

begin
  #Get history for domain name
  result = api_instance.domain_get(domain, country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling HistoricalApi->domain_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::HistoricalApi.new
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  from_date: 'from_date_example', # String | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  to_date: 'to_date_example', # String | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  url_filter: 'url_filter_example', # String | Filter answers to domains including a specified string
  lines: 50, # Integer | Get X results (max in one request is 10K please use offset paginated results if you need more)
  offset: 0 # Integer | Get paginated results from X offset
}

begin
  #Get historical stats for domains
  result = api_instance.domains_get(country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling HistoricalApi->domains_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::HistoricalApi.new
url = 'url_example' # String | Fully qualified page url. URL needs to be URL encoded
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  from_date: 'from_date_example', # String | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  to_date: 'to_date_example' # String | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
}

begin
  #Get page history for URL
  result = api_instance.page_get(url, country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling HistoricalApi->page_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::HistoricalApi.new
preset_filter = 56 # Integer | Apply preset filters => 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
opts = { 
  from_date: 'from_date_example', # String | Datas from YYYY-MM-DD (if not provided, last 30 days)
  to_date: 'to_date_example', # String | Datas to YYYY-MM-DD (if not provided, last 30 days)
  country: 'country_example', # String | ISO_3166 country code in 2 letters (if not provided  worldwide)
  subcountry: 'subcountry_example', # String | state code
  domain_filter: 'domain_filter_example', # String | Filter answers to pages of a designated domain name
  url_filter: 'url_filter_example', # String | Filter answers to pages URL including a specified string
  category_filter: 56, # Integer | Filter answers to a specific page category
  keyword_filter: 'keyword_filter_example', # String | Filter answers to pages titles containing a particular keyword
  lines: 50, # Integer | Get X results (max in one request is 50 please use offset paginated results if you need more)
  offset: 0 # Integer | Get paginated results from X offset
}

begin
  #Get historical stats for pages
  result = api_instance.pages_get(preset_filter, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling HistoricalApi->pages_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::KbApi.new
opts = { 
  article: 56 # Integer | ID of the requested article. 0 to get the full article list
}

begin
  #Get knowledge base articles
  result = api_instance.kb_articles_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling KbApi->kb_articles_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::LiveApi.new
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  hours: 56, # Integer | Get results for last x hours
  keyword_filter: 'keyword_filter_example', # String | Filter answers to category names containing a particular keyword
  language_filter: 'language_filter_example', # String | Filter answers to pages in specific user language
  lines: 50, # Integer | Get X results (max in one request is 10K please use offset paginated results if you need more)
  offset: 0 # Integer | Get paginated results from X offset
}

begin
  #Get livedata stats for categories
  result = api_instance.livecategories_get(country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling LiveApi->livecategories_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::LiveApi.new
country = 'country_example' # String | ISO_3166 country code in 2 letters
opts = { 
  subcountry: 'subcountry_example', # String | state code
  url_filter: 'url_filter_example', # String | Filter answers to domains including a specified string
  hours: 56, # Integer | Get results for last x hours
  lines: 50, # Integer | Get X results (max in one request is 10K please use offset paginated results if you need more)
  language_filter: 'language_filter_example', # String | Filter answers to pages in specific user language
  offset: 0 # Integer | Get paginated results from X offset
}

begin
  #Get livedata stats for domains
  result = api_instance.livedomains_get(country, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling LiveApi->livedomains_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::LiveApi.new
country = 'country_example' # String | ISO_3166 country code in 2 letters
preset_filter = 56 # Integer | Apply preset filters => 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
opts = { 
  subcountry: 'subcountry_example', # String | state code
  hours: 56, # Integer | Get results for last x hours
  only_new: 0, # Integer | Get only pages first seen in the reporting period if set on 1
  domain_filter: 'domain_filter_example', # String | Filter answers to pages of a designated domain name
  keyword_filter: 'keyword_filter_example', # String | Filter answers to pages titles containing a particular keyword
  url_filter: 'url_filter_example', # String | Filter answers to pages URL including a specified string
  category_filter: 56, # Integer | Filter answers to pages of a designated category id
  language_filter: 'language_filter_example', # String | Filter answers to pages in specific user language
  lines: 50, # Integer | Get X results (max in one request is 50 please use offset paginated results if you need more)
  offset: 0 # Integer | Get paginated results from X offset
}

begin
  #Get livedata stats for pages
  result = api_instance.livepages_get(country, preset_filter, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling LiveApi->livepages_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
countries = 'countries_example' # String | json encoded string representing countries to activate
categories = 'categories_example' # String | json encoded string representing categories ID to activate


begin
  #Change user's activated countries
  result = api_instance.user_countries_change_get(countries, categories)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_countries_change_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
custid = 'custid_example' # String | new customer id for user


begin
  #Change user customer id. This function is system reserved
  result = api_instance.user_custid_change_get(custid)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_custid_change_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new

begin
  #Permanently delete the user
  result = api_instance.user_delete_get
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_delete_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | new email address for user
fname = 'fname_example' # String | new firstname for user
lname = 'lname_example' # String | new lastname for user


begin
  #Change user details
  result = api_instance.user_details_change_get(email, fname, lname)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_details_change_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user
password = 'password_example' # String | password for user
opts = { 
  pin: 56 # Integer | pin code to validate account creation ; when using pin code, password must be set to \"loginwithpin\"
}

begin
  #Login user with his credentials
  result = api_instance.user_login_get(email, password, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_login_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
opts = { 
  message: 56 # Integer | ID of the requested message. 0 to get the full message list
}

begin
  #Get messages for user
  result = api_instance.user_messages_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_messages_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user
password = 'password_example' # String | current password for user
newpassword = 'newpassword_example' # String | new password to set up for user


begin
  #Change user password
  result = api_instance.user_password_change_get(email, password, newpassword)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_password_change_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user


begin
  #Reset user password
  result = api_instance.user_password_reset_get(email)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_password_reset_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
custid = 'custid_example' # String | Customer ID for the user


begin
  #Refresh user rights with his Customer ID. This function is system reserved
  result = api_instance.user_refresh_subscription_get(custid)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_refresh_subscription_get: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user
password = 'password_example' # String | password for user
fname = 'fname_example' # String | new firstname for user
lname = 'lname_example' # String | new lastname for user
opts = { 
  referrer: 'referrer_example' # String | referrer for this user. should be urlencoded
}

begin
  #Login user with his credentials
  result = api_instance.user_register_get(email, password, fname, lname, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_register_get: #{e}"
end
```

## Documentation for API Endpoints

All URIs are relative to *https://api.discoversnoop.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerClient::AlertsApi* | [**alerts_change_get**](docs/AlertsApi.md#alerts_change_get) | **GET** /alerts_change | Edit or insert new alert
*SwaggerClient::AlertsApi* | [**alerts_delete_get**](docs/AlertsApi.md#alerts_delete_get) | **GET** /alerts_delete | Permanently delete the alert
*SwaggerClient::AlertsApi* | [**alerts_get**](docs/AlertsApi.md#alerts_get) | **GET** /alerts | Get alerts for user account
*SwaggerClient::FavsApi* | [**favs_add_get**](docs/FavsApi.md#favs_add_get) | **GET** /favs_add | Create a new fav
*SwaggerClient::FavsApi* | [**favs_delete_get**](docs/FavsApi.md#favs_delete_get) | **GET** /favs_delete | Permanently delete the fav
*SwaggerClient::FavsApi* | [**favs_get**](docs/FavsApi.md#favs_get) | **GET** /favs | Get favorites
*SwaggerClient::FavsApi* | [**favs_update_get**](docs/FavsApi.md#favs_update_get) | **GET** /favs_update | Update the fav
*SwaggerClient::HistoricalApi* | [**categories_get**](docs/HistoricalApi.md#categories_get) | **GET** /categories | Get historical stats for categories
*SwaggerClient::HistoricalApi* | [**category_get**](docs/HistoricalApi.md#category_get) | **GET** /category | Get history for category ID
*SwaggerClient::HistoricalApi* | [**domain_get**](docs/HistoricalApi.md#domain_get) | **GET** /domain | Get history for domain name
*SwaggerClient::HistoricalApi* | [**domains_get**](docs/HistoricalApi.md#domains_get) | **GET** /domains | Get historical stats for domains
*SwaggerClient::HistoricalApi* | [**page_get**](docs/HistoricalApi.md#page_get) | **GET** /page | Get page history for URL
*SwaggerClient::HistoricalApi* | [**pages_get**](docs/HistoricalApi.md#pages_get) | **GET** /pages | Get historical stats for pages
*SwaggerClient::KbApi* | [**kb_articles_get**](docs/KbApi.md#kb_articles_get) | **GET** /kb_articles | Get knowledge base articles
*SwaggerClient::LiveApi* | [**livecategories_get**](docs/LiveApi.md#livecategories_get) | **GET** /livecategories | Get livedata stats for categories
*SwaggerClient::LiveApi* | [**livedomains_get**](docs/LiveApi.md#livedomains_get) | **GET** /livedomains | Get livedata stats for domains
*SwaggerClient::LiveApi* | [**livepages_get**](docs/LiveApi.md#livepages_get) | **GET** /livepages | Get livedata stats for pages
*SwaggerClient::UserApi* | [**user_countries_change_get**](docs/UserApi.md#user_countries_change_get) | **GET** /user_countries_change | Change user's activated countries
*SwaggerClient::UserApi* | [**user_custid_change_get**](docs/UserApi.md#user_custid_change_get) | **GET** /user_custid_change | Change user customer id. This function is system reserved
*SwaggerClient::UserApi* | [**user_delete_get**](docs/UserApi.md#user_delete_get) | **GET** /user_delete | Permanently delete the user
*SwaggerClient::UserApi* | [**user_details_change_get**](docs/UserApi.md#user_details_change_get) | **GET** /user_details_change | Change user details
*SwaggerClient::UserApi* | [**user_login_get**](docs/UserApi.md#user_login_get) | **GET** /user_login | Login user with his credentials
*SwaggerClient::UserApi* | [**user_messages_get**](docs/UserApi.md#user_messages_get) | **GET** /user_messages | Get messages for user
*SwaggerClient::UserApi* | [**user_password_change_get**](docs/UserApi.md#user_password_change_get) | **GET** /user_password_change | Change user password
*SwaggerClient::UserApi* | [**user_password_reset_get**](docs/UserApi.md#user_password_reset_get) | **GET** /user_password_reset | Reset user password
*SwaggerClient::UserApi* | [**user_refresh_subscription_get**](docs/UserApi.md#user_refresh_subscription_get) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
*SwaggerClient::UserApi* | [**user_register_get**](docs/UserApi.md#user_register_get) | **GET** /user_register | Login user with his credentials

## Documentation for Models

 - [SwaggerClient::AlertCollection](docs/AlertCollection.md)
 - [SwaggerClient::Alerts](docs/Alerts.md)
 - [SwaggerClient::Categories](docs/Categories.md)
 - [SwaggerClient::CategoriesCollection](docs/CategoriesCollection.md)
 - [SwaggerClient::Category](docs/Category.md)
 - [SwaggerClient::DistributionCollection](docs/DistributionCollection.md)
 - [SwaggerClient::Domain](docs/Domain.md)
 - [SwaggerClient::Domains](docs/Domains.md)
 - [SwaggerClient::DomainsCollection](docs/DomainsCollection.md)
 - [SwaggerClient::Favs](docs/Favs.md)
 - [SwaggerClient::FavsCollection](docs/FavsCollection.md)
 - [SwaggerClient::HistoryCollection](docs/HistoryCollection.md)
 - [SwaggerClient::KB](docs/KB.md)
 - [SwaggerClient::KBCollection](docs/KBCollection.md)
 - [SwaggerClient::Message](docs/Message.md)
 - [SwaggerClient::MessageCollection](docs/MessageCollection.md)
 - [SwaggerClient::MetricsCollection](docs/MetricsCollection.md)
 - [SwaggerClient::Page](docs/Page.md)
 - [SwaggerClient::Pages](docs/Pages.md)
 - [SwaggerClient::PagesCollection](docs/PagesCollection.md)
 - [SwaggerClient::TransactionInfo](docs/TransactionInfo.md)
 - [SwaggerClient::UserCollection](docs/UserCollection.md)
 - [SwaggerClient::UserInfo](docs/UserInfo.md)

## Documentation for Authorization


### bearerAuth


