# SwaggerClient::AlertsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**alerts_change_get**](AlertsApi.md#alerts_change_get) | **GET** /alerts_change | Edit or insert new alert
[**alerts_delete_get**](AlertsApi.md#alerts_delete_get) | **GET** /alerts_delete | Permanently delete the alert
[**alerts_get**](AlertsApi.md#alerts_get) | **GET** /alerts | Get alerts for user account

# **alerts_change_get**
> Array&lt;Domains&gt; alerts_change_get(id, alertname, activated, type, channel, recipient, opts)

Edit or insert new alert

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::AlertsApi.new
id = 'id_example' # String | ID of the alert to edit ; if adding a new one leave blank
alertname = 'alertname_example' # String | Name of the alert
activated = true # BOOLEAN | Should the alert be activated or not
type = 56 # Integer | Alert type (1= New content for website, 2=New perfirming contents)
channel = 56 # Integer | 1 for email, 2 for Slack, 3 for Google Chat
recipient = 'recipient_example' # String | Email address of recipient or webhook for Slack/Gchat
opts = { 
  param1: 'param1_example', # String | Parameter 1 (meaning changes with alert type)
  param2: 'param2_example', # String | Parameter 2 (meaning changes with alert type)
  param3: 'param3_example', # String | Parameter 3 (meaning changes with alert type)
  param4: 'param4_example', # String | Parameter 4 (meaning changes with alert type)
  param5: 'param5_example' # String | Parameter 5 (meaning changes with alert type)
}

begin
  #Edit or insert new alert
  result = api_instance.alerts_change_get(id, alertname, activated, type, channel, recipient, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AlertsApi->alerts_change_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the alert to edit ; if adding a new one leave blank | 
 **alertname** | **String**| Name of the alert | 
 **activated** | **BOOLEAN**| Should the alert be activated or not | 
 **type** | **Integer**| Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) | 
 **channel** | **Integer**| 1 for email, 2 for Slack, 3 for Google Chat | 
 **recipient** | **String**| Email address of recipient or webhook for Slack/Gchat | 
 **param1** | **String**| Parameter 1 (meaning changes with alert type) | [optional] 
 **param2** | **String**| Parameter 2 (meaning changes with alert type) | [optional] 
 **param3** | **String**| Parameter 3 (meaning changes with alert type) | [optional] 
 **param4** | **String**| Parameter 4 (meaning changes with alert type) | [optional] 
 **param5** | **String**| Parameter 5 (meaning changes with alert type) | [optional] 

### Return type

[**Array&lt;Domains&gt;**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **alerts_delete_get**
> Array&lt;TransactionInfo&gt; alerts_delete_get(id)

Permanently delete the alert

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::AlertsApi.new
id = 'id_example' # String | alert id to delete


begin
  #Permanently delete the alert
  result = api_instance.alerts_delete_get(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AlertsApi->alerts_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| alert id to delete | 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **alerts_get**
> Array&lt;Alerts&gt; alerts_get

Get alerts for user account

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::AlertsApi.new

begin
  #Get alerts for user account
  result = api_instance.alerts_get
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling AlertsApi->alerts_get: #{e}"
end
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**Array&lt;Alerts&gt;**](Alerts.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



