# SwaggerClient::FavsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**favs_add_get**](FavsApi.md#favs_add_get) | **GET** /favs_add | Create a new fav
[**favs_delete_get**](FavsApi.md#favs_delete_get) | **GET** /favs_delete | Permanently delete the fav
[**favs_get**](FavsApi.md#favs_get) | **GET** /favs | Get favorites
[**favs_update_get**](FavsApi.md#favs_update_get) | **GET** /favs_update | Update the fav

# **favs_add_get**
> Array&lt;TransactionInfo&gt; favs_add_get(opts)

Create a new fav

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
opts = { 
  name: 'name_example', # String | Name of the fav.
  action: 'action_example', # String | Action to be opened.
  parameters: 'parameters_example' # String | Action's parameters encoded in JSON.
}

begin
  #Create a new fav
  result = api_instance.favs_add_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_add_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**| Name of the fav. | [optional] 
 **action** | **String**| Action to be opened. | [optional] 
 **parameters** | **String**| Action&#x27;s parameters encoded in JSON. | [optional] 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **favs_delete_get**
> Array&lt;TransactionInfo&gt; favs_delete_get(opts)

Permanently delete the fav

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
opts = { 
  id: 'id_example' # String | ID of the fav to delete.
}

begin
  #Permanently delete the fav
  result = api_instance.favs_delete_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_delete_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the fav to delete. | [optional] 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **favs_get**
> Array&lt;Favs&gt; favs_get(opts)

Get favorites

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
opts = { 
  id: 'id_example' # String | ID of the requested fav. ignore or set to 0 to get the full favs list
}

begin
  #Get favorites
  result = api_instance.favs_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the requested fav. ignore or set to 0 to get the full favs list | [optional] 

### Return type

[**Array&lt;Favs&gt;**](Favs.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **favs_update_get**
> Array&lt;TransactionInfo&gt; favs_update_get(id, opts)

Update the fav

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::FavsApi.new
id = 'id_example' # String | ID of the fav that should be edited
opts = { 
  name: 'name_example', # String | Name of the fav.
  action: 'action_example', # String | Action to be opened.
  parameters: 'parameters_example', # String | Action's parameters encoded in JSON.
  scheduled: 56, # Integer | 0 if not scheduled, else x in hours
  scheduledto: 'scheduledto_example' # String | email address of the recipient of this report
}

begin
  #Update the fav
  result = api_instance.favs_update_get(id, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling FavsApi->favs_update_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the fav that should be edited | 
 **name** | **String**| Name of the fav. | [optional] 
 **action** | **String**| Action to be opened. | [optional] 
 **parameters** | **String**| Action&#x27;s parameters encoded in JSON. | [optional] 
 **scheduled** | **Integer**| 0 if not scheduled, else x in hours | [optional] 
 **scheduledto** | **String**| email address of the recipient of this report | [optional] 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



