# SwaggerClient::KbApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**kb_articles_get**](KbApi.md#kb_articles_get) | **GET** /kb_articles | Get knowledge base articles

# **kb_articles_get**
> Array&lt;KB&gt; kb_articles_get(opts)

Get knowledge base articles

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::KbApi.new
opts = { 
  article: 56 # Integer | ID of the requested article. 0 to get the full article list
}

begin
  #Get knowledge base articles
  result = api_instance.kb_articles_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling KbApi->kb_articles_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **article** | **Integer**| ID of the requested article. 0 to get the full article list | [optional] 

### Return type

[**Array&lt;KB&gt;**](KB.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



