# SwaggerClient::UserApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**user_countries_change_get**](UserApi.md#user_countries_change_get) | **GET** /user_countries_change | Change user&#x27;s activated countries
[**user_custid_change_get**](UserApi.md#user_custid_change_get) | **GET** /user_custid_change | Change user customer id. This function is system reserved
[**user_delete_get**](UserApi.md#user_delete_get) | **GET** /user_delete | Permanently delete the user
[**user_details_change_get**](UserApi.md#user_details_change_get) | **GET** /user_details_change | Change user details
[**user_login_get**](UserApi.md#user_login_get) | **GET** /user_login | Login user with his credentials
[**user_messages_get**](UserApi.md#user_messages_get) | **GET** /user_messages | Get messages for user
[**user_password_change_get**](UserApi.md#user_password_change_get) | **GET** /user_password_change | Change user password
[**user_password_reset_get**](UserApi.md#user_password_reset_get) | **GET** /user_password_reset | Reset user password
[**user_refresh_subscription_get**](UserApi.md#user_refresh_subscription_get) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
[**user_register_get**](UserApi.md#user_register_get) | **GET** /user_register | Login user with his credentials

# **user_countries_change_get**
> Array&lt;TransactionInfo&gt; user_countries_change_get(countries, categories)

Change user's activated countries

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
countries = 'countries_example' # String | json encoded string representing countries to activate
categories = 'categories_example' # String | json encoded string representing categories ID to activate


begin
  #Change user's activated countries
  result = api_instance.user_countries_change_get(countries, categories)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_countries_change_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **countries** | **String**| json encoded string representing countries to activate | 
 **categories** | **String**| json encoded string representing categories ID to activate | 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_custid_change_get**
> Array&lt;TransactionInfo&gt; user_custid_change_get(custid)

Change user customer id. This function is system reserved

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
custid = 'custid_example' # String | new customer id for user


begin
  #Change user customer id. This function is system reserved
  result = api_instance.user_custid_change_get(custid)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_custid_change_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **String**| new customer id for user | 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_delete_get**
> Array&lt;TransactionInfo&gt; user_delete_get

Permanently delete the user

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new

begin
  #Permanently delete the user
  result = api_instance.user_delete_get
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_delete_get: #{e}"
end
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_details_change_get**
> Array&lt;TransactionInfo&gt; user_details_change_get(email, fname, lname)

Change user details

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | new email address for user
fname = 'fname_example' # String | new firstname for user
lname = 'lname_example' # String | new lastname for user


begin
  #Change user details
  result = api_instance.user_details_change_get(email, fname, lname)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_details_change_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| new email address for user | 
 **fname** | **String**| new firstname for user | 
 **lname** | **String**| new lastname for user | 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_login_get**
> Array&lt;UserInfo&gt; user_login_get(email, password, opts)

Login user with his credentials

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user
password = 'password_example' # String | password for user
opts = { 
  pin: 56 # Integer | pin code to validate account creation ; when using pin code, password must be set to \"loginwithpin\"
}

begin
  #Login user with his credentials
  result = api_instance.user_login_get(email, password, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_login_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user | 
 **password** | **String**| password for user | 
 **pin** | **Integer**| pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; | [optional] 

### Return type

[**Array&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_messages_get**
> Array&lt;Message&gt; user_messages_get(opts)

Get messages for user

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
opts = { 
  message: 56 # Integer | ID of the requested message. 0 to get the full message list
}

begin
  #Get messages for user
  result = api_instance.user_messages_get(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_messages_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **message** | **Integer**| ID of the requested message. 0 to get the full message list | [optional] 

### Return type

[**Array&lt;Message&gt;**](Message.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_password_change_get**
> Array&lt;TransactionInfo&gt; user_password_change_get(email, password, newpassword)

Change user password

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user
password = 'password_example' # String | current password for user
newpassword = 'newpassword_example' # String | new password to set up for user


begin
  #Change user password
  result = api_instance.user_password_change_get(email, password, newpassword)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_password_change_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user | 
 **password** | **String**| current password for user | 
 **newpassword** | **String**| new password to set up for user | 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_password_reset_get**
> Array&lt;TransactionInfo&gt; user_password_reset_get(email)

Reset user password

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user


begin
  #Reset user password
  result = api_instance.user_password_reset_get(email)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_password_reset_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user | 

### Return type

[**Array&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_refresh_subscription_get**
> Array&lt;UserInfo&gt; user_refresh_subscription_get(custid)

Refresh user rights with his Customer ID. This function is system reserved

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
custid = 'custid_example' # String | Customer ID for the user


begin
  #Refresh user rights with his Customer ID. This function is system reserved
  result = api_instance.user_refresh_subscription_get(custid)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_refresh_subscription_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **String**| Customer ID for the user | 

### Return type

[**Array&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **user_register_get**
> Array&lt;UserInfo&gt; user_register_get(email, password, fname, lname, opts)

Login user with his credentials

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
end

api_instance = SwaggerClient::UserApi.new
email = 'email_example' # String | email address for user
password = 'password_example' # String | password for user
fname = 'fname_example' # String | new firstname for user
lname = 'lname_example' # String | new lastname for user
opts = { 
  referrer: 'referrer_example' # String | referrer for this user. should be urlencoded
}

begin
  #Login user with his credentials
  result = api_instance.user_register_get(email, password, fname, lname, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling UserApi->user_register_get: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user | 
 **password** | **String**| password for user | 
 **fname** | **String**| new firstname for user | 
 **lname** | **String**| new lastname for user | 
 **referrer** | **String**| referrer for this user. should be urlencoded | [optional] 

### Return type

[**Array&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



