=begin
#DiscoverSnoop

#API for DiscoverSnoop Service

OpenAPI spec version: 0.9.240913

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.62
=end

module SwaggerClient
  class AlertsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Edit or insert new alert
    # @param id ID of the alert to edit ; if adding a new one leave blank
    # @param alertname Name of the alert
    # @param activated Should the alert be activated or not
    # @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents)
    # @param channel 1 for email, 2 for Slack, 3 for Google Chat
    # @param recipient Email address of recipient or webhook for Slack/Gchat
    # @param [Hash] opts the optional parameters
    # @option opts [String] :param1 Parameter 1 (meaning changes with alert type)
    # @option opts [String] :param2 Parameter 2 (meaning changes with alert type)
    # @option opts [String] :param3 Parameter 3 (meaning changes with alert type)
    # @option opts [String] :param4 Parameter 4 (meaning changes with alert type)
    # @option opts [String] :param5 Parameter 5 (meaning changes with alert type)
    # @return [Array<Domains>]
    def alerts_change_get(id, alertname, activated, type, channel, recipient, opts = {})
      data, _status_code, _headers = alerts_change_get_with_http_info(id, alertname, activated, type, channel, recipient, opts)
      data
    end

    # Edit or insert new alert
    # @param id ID of the alert to edit ; if adding a new one leave blank
    # @param alertname Name of the alert
    # @param activated Should the alert be activated or not
    # @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents)
    # @param channel 1 for email, 2 for Slack, 3 for Google Chat
    # @param recipient Email address of recipient or webhook for Slack/Gchat
    # @param [Hash] opts the optional parameters
    # @option opts [String] :param1 Parameter 1 (meaning changes with alert type)
    # @option opts [String] :param2 Parameter 2 (meaning changes with alert type)
    # @option opts [String] :param3 Parameter 3 (meaning changes with alert type)
    # @option opts [String] :param4 Parameter 4 (meaning changes with alert type)
    # @option opts [String] :param5 Parameter 5 (meaning changes with alert type)
    # @return [Array<(Array<Domains>, Integer, Hash)>] Array<Domains> data, response status code and response headers
    def alerts_change_get_with_http_info(id, alertname, activated, type, channel, recipient, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AlertsApi.alerts_change_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AlertsApi.alerts_change_get"
      end
      # verify the required parameter 'alertname' is set
      if @api_client.config.client_side_validation && alertname.nil?
        fail ArgumentError, "Missing the required parameter 'alertname' when calling AlertsApi.alerts_change_get"
      end
      # verify the required parameter 'activated' is set
      if @api_client.config.client_side_validation && activated.nil?
        fail ArgumentError, "Missing the required parameter 'activated' when calling AlertsApi.alerts_change_get"
      end
      # verify the required parameter 'type' is set
      if @api_client.config.client_side_validation && type.nil?
        fail ArgumentError, "Missing the required parameter 'type' when calling AlertsApi.alerts_change_get"
      end
      # verify the required parameter 'channel' is set
      if @api_client.config.client_side_validation && channel.nil?
        fail ArgumentError, "Missing the required parameter 'channel' when calling AlertsApi.alerts_change_get"
      end
      # verify the required parameter 'recipient' is set
      if @api_client.config.client_side_validation && recipient.nil?
        fail ArgumentError, "Missing the required parameter 'recipient' when calling AlertsApi.alerts_change_get"
      end
      # resource path
      local_var_path = '/alerts_change'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = id
      query_params[:'alertname'] = alertname
      query_params[:'activated'] = activated
      query_params[:'type'] = type
      query_params[:'channel'] = channel
      query_params[:'recipient'] = recipient
      query_params[:'param1'] = opts[:'param1'] if !opts[:'param1'].nil?
      query_params[:'param2'] = opts[:'param2'] if !opts[:'param2'].nil?
      query_params[:'param3'] = opts[:'param3'] if !opts[:'param3'].nil?
      query_params[:'param4'] = opts[:'param4'] if !opts[:'param4'].nil?
      query_params[:'param5'] = opts[:'param5'] if !opts[:'param5'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Domains>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AlertsApi#alerts_change_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Permanently delete the alert
    # @param id alert id to delete
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def alerts_delete_get(id, opts = {})
      data, _status_code, _headers = alerts_delete_get_with_http_info(id, opts)
      data
    end

    # Permanently delete the alert
    # @param id alert id to delete
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def alerts_delete_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AlertsApi.alerts_delete_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AlertsApi.alerts_delete_get"
      end
      # resource path
      local_var_path = '/alerts_delete'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = id

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AlertsApi#alerts_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get alerts for user account
    # @param [Hash] opts the optional parameters
    # @return [Array<Alerts>]
    def alerts_get(opts = {})
      data, _status_code, _headers = alerts_get_with_http_info(opts)
      data
    end

    # Get alerts for user account
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Alerts>, Integer, Hash)>] Array<Alerts> data, response status code and response headers
    def alerts_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AlertsApi.alerts_get ...'
      end
      # resource path
      local_var_path = '/alerts'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Alerts>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AlertsApi#alerts_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
