=begin
#DiscoverSnoop

#API for DiscoverSnoop Service

OpenAPI spec version: 0.9.240913

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.62
=end

module SwaggerClient
  class FavsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new fav
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Name of the fav.
    # @option opts [String] :action Action to be opened.
    # @option opts [String] :parameters Action&#x27;s parameters encoded in JSON.
    # @return [Array<TransactionInfo>]
    def favs_add_get(opts = {})
      data, _status_code, _headers = favs_add_get_with_http_info(opts)
      data
    end

    # Create a new fav
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Name of the fav.
    # @option opts [String] :action Action to be opened.
    # @option opts [String] :parameters Action&#x27;s parameters encoded in JSON.
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def favs_add_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FavsApi.favs_add_get ...'
      end
      # resource path
      local_var_path = '/favs_add'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'action'] = opts[:'action'] if !opts[:'action'].nil?
      query_params[:'parameters'] = opts[:'parameters'] if !opts[:'parameters'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FavsApi#favs_add_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Permanently delete the fav
    # @param [Hash] opts the optional parameters
    # @option opts [String] :id ID of the fav to delete.
    # @return [Array<TransactionInfo>]
    def favs_delete_get(opts = {})
      data, _status_code, _headers = favs_delete_get_with_http_info(opts)
      data
    end

    # Permanently delete the fav
    # @param [Hash] opts the optional parameters
    # @option opts [String] :id ID of the fav to delete.
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def favs_delete_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FavsApi.favs_delete_get ...'
      end
      # resource path
      local_var_path = '/favs_delete'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = opts[:'id'] if !opts[:'id'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FavsApi#favs_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get favorites
    # @param [Hash] opts the optional parameters
    # @option opts [String] :id ID of the requested fav. ignore or set to 0 to get the full favs list
    # @return [Array<Favs>]
    def favs_get(opts = {})
      data, _status_code, _headers = favs_get_with_http_info(opts)
      data
    end

    # Get favorites
    # @param [Hash] opts the optional parameters
    # @option opts [String] :id ID of the requested fav. ignore or set to 0 to get the full favs list
    # @return [Array<(Array<Favs>, Integer, Hash)>] Array<Favs> data, response status code and response headers
    def favs_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FavsApi.favs_get ...'
      end
      # resource path
      local_var_path = '/favs'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = opts[:'id'] if !opts[:'id'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Favs>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FavsApi#favs_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update the fav
    # @param id ID of the fav that should be edited
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Name of the fav.
    # @option opts [String] :action Action to be opened.
    # @option opts [String] :parameters Action&#x27;s parameters encoded in JSON.
    # @option opts [Integer] :scheduled 0 if not scheduled, else x in hours
    # @option opts [String] :scheduledto email address of the recipient of this report
    # @return [Array<TransactionInfo>]
    def favs_update_get(id, opts = {})
      data, _status_code, _headers = favs_update_get_with_http_info(id, opts)
      data
    end

    # Update the fav
    # @param id ID of the fav that should be edited
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Name of the fav.
    # @option opts [String] :action Action to be opened.
    # @option opts [String] :parameters Action&#x27;s parameters encoded in JSON.
    # @option opts [Integer] :scheduled 0 if not scheduled, else x in hours
    # @option opts [String] :scheduledto email address of the recipient of this report
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def favs_update_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FavsApi.favs_update_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FavsApi.favs_update_get"
      end
      # resource path
      local_var_path = '/favs_update'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = id
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'action'] = opts[:'action'] if !opts[:'action'].nil?
      query_params[:'parameters'] = opts[:'parameters'] if !opts[:'parameters'].nil?
      query_params[:'scheduled'] = opts[:'scheduled'] if !opts[:'scheduled'].nil?
      query_params[:'scheduledto'] = opts[:'scheduledto'] if !opts[:'scheduledto'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FavsApi#favs_update_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
