=begin
#DiscoverSnoop

#API for DiscoverSnoop Service

OpenAPI spec version: 0.9.240913

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.62
=end

module SwaggerClient
  class HistoricalApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get historical stats for categories
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :keyword_filter Filter answers to cateogry names containing a particular keyword
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more) (default to 50)
    # @option opts [Integer] :offset Get paginated results from X offset (default to 0)
    # @return [Array<Categories>]
    def categories_get(country, opts = {})
      data, _status_code, _headers = categories_get_with_http_info(country, opts)
      data
    end

    # Get historical stats for categories
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :keyword_filter Filter answers to cateogry names containing a particular keyword
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more)
    # @option opts [Integer] :offset Get paginated results from X offset
    # @return [Array<(Array<Categories>, Integer, Hash)>] Array<Categories> data, response status code and response headers
    def categories_get_with_http_info(country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HistoricalApi.categories_get ...'
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling HistoricalApi.categories_get"
      end
      # resource path
      local_var_path = '/categories'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'from_date'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'to_date'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'keyword_filter'] = opts[:'keyword_filter'] if !opts[:'keyword_filter'].nil?
      query_params[:'lines'] = opts[:'lines'] if !opts[:'lines'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Categories>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HistoricalApi#categories_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get history for category ID
    # @param id category id
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @return [Array<Category>]
    def category_get(id, country, opts = {})
      data, _status_code, _headers = category_get_with_http_info(id, country, opts)
      data
    end

    # Get history for category ID
    # @param id category id
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @return [Array<(Array<Category>, Integer, Hash)>] Array<Category> data, response status code and response headers
    def category_get_with_http_info(id, country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HistoricalApi.category_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling HistoricalApi.category_get"
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling HistoricalApi.category_get"
      end
      # resource path
      local_var_path = '/category'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = id
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'from_date'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'to_date'] = opts[:'to_date'] if !opts[:'to_date'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Category>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HistoricalApi#category_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get history for domain name
    # @param domain domain name (no subdomain allowed)
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @return [Array<Domain>]
    def domain_get(domain, country, opts = {})
      data, _status_code, _headers = domain_get_with_http_info(domain, country, opts)
      data
    end

    # Get history for domain name
    # @param domain domain name (no subdomain allowed)
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @return [Array<(Array<Domain>, Integer, Hash)>] Array<Domain> data, response status code and response headers
    def domain_get_with_http_info(domain, country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HistoricalApi.domain_get ...'
      end
      # verify the required parameter 'domain' is set
      if @api_client.config.client_side_validation && domain.nil?
        fail ArgumentError, "Missing the required parameter 'domain' when calling HistoricalApi.domain_get"
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling HistoricalApi.domain_get"
      end
      # resource path
      local_var_path = '/domain'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'domain'] = domain
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'from_date'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'to_date'] = opts[:'to_date'] if !opts[:'to_date'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Domain>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HistoricalApi#domain_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get historical stats for domains
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :url_filter Filter answers to domains including a specified string
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more) (default to 50)
    # @option opts [Integer] :offset Get paginated results from X offset (default to 0)
    # @return [Array<Domains>]
    def domains_get(country, opts = {})
      data, _status_code, _headers = domains_get_with_http_info(country, opts)
      data
    end

    # Get historical stats for domains
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :url_filter Filter answers to domains including a specified string
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more)
    # @option opts [Integer] :offset Get paginated results from X offset
    # @return [Array<(Array<Domains>, Integer, Hash)>] Array<Domains> data, response status code and response headers
    def domains_get_with_http_info(country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HistoricalApi.domains_get ...'
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling HistoricalApi.domains_get"
      end
      # resource path
      local_var_path = '/domains'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'from_date'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'to_date'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'url_filter'] = opts[:'url_filter'] if !opts[:'url_filter'].nil?
      query_params[:'lines'] = opts[:'lines'] if !opts[:'lines'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Domains>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HistoricalApi#domains_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get page history for URL
    # @param url Fully qualified page url. URL needs to be URL encoded
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @return [Array<Page>]
    def page_get(url, country, opts = {})
      data, _status_code, _headers = page_get_with_http_info(url, country, opts)
      data
    end

    # Get page history for URL
    # @param url Fully qualified page url. URL needs to be URL encoded
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
    # @return [Array<(Array<Page>, Integer, Hash)>] Array<Page> data, response status code and response headers
    def page_get_with_http_info(url, country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HistoricalApi.page_get ...'
      end
      # verify the required parameter 'url' is set
      if @api_client.config.client_side_validation && url.nil?
        fail ArgumentError, "Missing the required parameter 'url' when calling HistoricalApi.page_get"
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling HistoricalApi.page_get"
      end
      # resource path
      local_var_path = '/page'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'url'] = url
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'from_date'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'to_date'] = opts[:'to_date'] if !opts[:'to_date'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Page>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HistoricalApi#page_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get historical stats for pages
    # @param preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, last 30 days)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, last 30 days)
    # @option opts [String] :country ISO_3166 country code in 2 letters (if not provided  worldwide)
    # @option opts [String] :subcountry state code
    # @option opts [String] :domain_filter Filter answers to pages of a designated domain name
    # @option opts [String] :url_filter Filter answers to pages URL including a specified string
    # @option opts [Integer] :category_filter Filter answers to a specific page category
    # @option opts [String] :keyword_filter Filter answers to pages titles containing a particular keyword
    # @option opts [Integer] :lines Get X results (max in one request is 50 please use offset paginated results if you need more) (default to 50)
    # @option opts [Integer] :offset Get paginated results from X offset (default to 0)
    # @return [Array<Pages>]
    def pages_get(preset_filter, opts = {})
      data, _status_code, _headers = pages_get_with_http_info(preset_filter, opts)
      data
    end

    # Get historical stats for pages
    # @param preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
    # @param [Hash] opts the optional parameters
    # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, last 30 days)
    # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, last 30 days)
    # @option opts [String] :country ISO_3166 country code in 2 letters (if not provided  worldwide)
    # @option opts [String] :subcountry state code
    # @option opts [String] :domain_filter Filter answers to pages of a designated domain name
    # @option opts [String] :url_filter Filter answers to pages URL including a specified string
    # @option opts [Integer] :category_filter Filter answers to a specific page category
    # @option opts [String] :keyword_filter Filter answers to pages titles containing a particular keyword
    # @option opts [Integer] :lines Get X results (max in one request is 50 please use offset paginated results if you need more)
    # @option opts [Integer] :offset Get paginated results from X offset
    # @return [Array<(Array<Pages>, Integer, Hash)>] Array<Pages> data, response status code and response headers
    def pages_get_with_http_info(preset_filter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HistoricalApi.pages_get ...'
      end
      # verify the required parameter 'preset_filter' is set
      if @api_client.config.client_side_validation && preset_filter.nil?
        fail ArgumentError, "Missing the required parameter 'preset_filter' when calling HistoricalApi.pages_get"
      end
      # resource path
      local_var_path = '/pages'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'preset_filter'] = preset_filter
      query_params[:'from_date'] = opts[:'from_date'] if !opts[:'from_date'].nil?
      query_params[:'to_date'] = opts[:'to_date'] if !opts[:'to_date'].nil?
      query_params[:'country'] = opts[:'country'] if !opts[:'country'].nil?
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'domain_filter'] = opts[:'domain_filter'] if !opts[:'domain_filter'].nil?
      query_params[:'url_filter'] = opts[:'url_filter'] if !opts[:'url_filter'].nil?
      query_params[:'category_filter'] = opts[:'category_filter'] if !opts[:'category_filter'].nil?
      query_params[:'keyword_filter'] = opts[:'keyword_filter'] if !opts[:'keyword_filter'].nil?
      query_params[:'lines'] = opts[:'lines'] if !opts[:'lines'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Pages>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HistoricalApi#pages_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
