=begin
#DiscoverSnoop

#API for DiscoverSnoop Service

OpenAPI spec version: 0.9.240913

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.62
=end

module SwaggerClient
  class LiveApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get livedata stats for categories
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [Integer] :hours Get results for last x hours
    # @option opts [String] :keyword_filter Filter answers to category names containing a particular keyword
    # @option opts [String] :language_filter Filter answers to pages in specific user language
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more) (default to 50)
    # @option opts [Integer] :offset Get paginated results from X offset (default to 0)
    # @return [Array<Categories>]
    def livecategories_get(country, opts = {})
      data, _status_code, _headers = livecategories_get_with_http_info(country, opts)
      data
    end

    # Get livedata stats for categories
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [Integer] :hours Get results for last x hours
    # @option opts [String] :keyword_filter Filter answers to category names containing a particular keyword
    # @option opts [String] :language_filter Filter answers to pages in specific user language
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more)
    # @option opts [Integer] :offset Get paginated results from X offset
    # @return [Array<(Array<Categories>, Integer, Hash)>] Array<Categories> data, response status code and response headers
    def livecategories_get_with_http_info(country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LiveApi.livecategories_get ...'
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling LiveApi.livecategories_get"
      end
      # resource path
      local_var_path = '/livecategories'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'hours'] = opts[:'hours'] if !opts[:'hours'].nil?
      query_params[:'keyword_filter'] = opts[:'keyword_filter'] if !opts[:'keyword_filter'].nil?
      query_params[:'language_filter'] = opts[:'language_filter'] if !opts[:'language_filter'].nil?
      query_params[:'lines'] = opts[:'lines'] if !opts[:'lines'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Categories>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LiveApi#livecategories_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get livedata stats for domains
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :url_filter Filter answers to domains including a specified string
    # @option opts [Integer] :hours Get results for last x hours
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more) (default to 50)
    # @option opts [String] :language_filter Filter answers to pages in specific user language
    # @option opts [Integer] :offset Get paginated results from X offset (default to 0)
    # @return [Array<Domains>]
    def livedomains_get(country, opts = {})
      data, _status_code, _headers = livedomains_get_with_http_info(country, opts)
      data
    end

    # Get livedata stats for domains
    # @param country ISO_3166 country code in 2 letters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [String] :url_filter Filter answers to domains including a specified string
    # @option opts [Integer] :hours Get results for last x hours
    # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more)
    # @option opts [String] :language_filter Filter answers to pages in specific user language
    # @option opts [Integer] :offset Get paginated results from X offset
    # @return [Array<(Array<Domains>, Integer, Hash)>] Array<Domains> data, response status code and response headers
    def livedomains_get_with_http_info(country, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LiveApi.livedomains_get ...'
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling LiveApi.livedomains_get"
      end
      # resource path
      local_var_path = '/livedomains'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'country'] = country
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'url_filter'] = opts[:'url_filter'] if !opts[:'url_filter'].nil?
      query_params[:'hours'] = opts[:'hours'] if !opts[:'hours'].nil?
      query_params[:'lines'] = opts[:'lines'] if !opts[:'lines'].nil?
      query_params[:'language_filter'] = opts[:'language_filter'] if !opts[:'language_filter'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Domains>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LiveApi#livedomains_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get livedata stats for pages
    # @param country ISO_3166 country code in 2 letters
    # @param preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [Integer] :hours Get results for last x hours
    # @option opts [Integer] :only_new Get only pages first seen in the reporting period if set on 1 (default to 0)
    # @option opts [String] :domain_filter Filter answers to pages of a designated domain name
    # @option opts [String] :keyword_filter Filter answers to pages titles containing a particular keyword
    # @option opts [String] :url_filter Filter answers to pages URL including a specified string
    # @option opts [Integer] :category_filter Filter answers to pages of a designated category id
    # @option opts [String] :language_filter Filter answers to pages in specific user language
    # @option opts [Integer] :lines Get X results (max in one request is 50 please use offset paginated results if you need more) (default to 50)
    # @option opts [Integer] :offset Get paginated results from X offset (default to 0)
    # @return [Array<Pages>]
    def livepages_get(country, preset_filter, opts = {})
      data, _status_code, _headers = livepages_get_with_http_info(country, preset_filter, opts)
      data
    end

    # Get livedata stats for pages
    # @param country ISO_3166 country code in 2 letters
    # @param preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
    # @param [Hash] opts the optional parameters
    # @option opts [String] :subcountry state code
    # @option opts [Integer] :hours Get results for last x hours
    # @option opts [Integer] :only_new Get only pages first seen in the reporting period if set on 1
    # @option opts [String] :domain_filter Filter answers to pages of a designated domain name
    # @option opts [String] :keyword_filter Filter answers to pages titles containing a particular keyword
    # @option opts [String] :url_filter Filter answers to pages URL including a specified string
    # @option opts [Integer] :category_filter Filter answers to pages of a designated category id
    # @option opts [String] :language_filter Filter answers to pages in specific user language
    # @option opts [Integer] :lines Get X results (max in one request is 50 please use offset paginated results if you need more)
    # @option opts [Integer] :offset Get paginated results from X offset
    # @return [Array<(Array<Pages>, Integer, Hash)>] Array<Pages> data, response status code and response headers
    def livepages_get_with_http_info(country, preset_filter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LiveApi.livepages_get ...'
      end
      # verify the required parameter 'country' is set
      if @api_client.config.client_side_validation && country.nil?
        fail ArgumentError, "Missing the required parameter 'country' when calling LiveApi.livepages_get"
      end
      # verify the required parameter 'preset_filter' is set
      if @api_client.config.client_side_validation && preset_filter.nil?
        fail ArgumentError, "Missing the required parameter 'preset_filter' when calling LiveApi.livepages_get"
      end
      # resource path
      local_var_path = '/livepages'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'country'] = country
      query_params[:'preset_filter'] = preset_filter
      query_params[:'subcountry'] = opts[:'subcountry'] if !opts[:'subcountry'].nil?
      query_params[:'hours'] = opts[:'hours'] if !opts[:'hours'].nil?
      query_params[:'only_new'] = opts[:'only_new'] if !opts[:'only_new'].nil?
      query_params[:'domain_filter'] = opts[:'domain_filter'] if !opts[:'domain_filter'].nil?
      query_params[:'keyword_filter'] = opts[:'keyword_filter'] if !opts[:'keyword_filter'].nil?
      query_params[:'url_filter'] = opts[:'url_filter'] if !opts[:'url_filter'].nil?
      query_params[:'category_filter'] = opts[:'category_filter'] if !opts[:'category_filter'].nil?
      query_params[:'language_filter'] = opts[:'language_filter'] if !opts[:'language_filter'].nil?
      query_params[:'lines'] = opts[:'lines'] if !opts[:'lines'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Pages>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LiveApi#livepages_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
