=begin
#DiscoverSnoop

#API for DiscoverSnoop Service

OpenAPI spec version: 0.9.240913

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.62
=end

module SwaggerClient
  class UserApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Change user's activated countries
    # @param countries json encoded string representing countries to activate
    # @param categories json encoded string representing categories ID to activate
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def user_countries_change_get(countries, categories, opts = {})
      data, _status_code, _headers = user_countries_change_get_with_http_info(countries, categories, opts)
      data
    end

    # Change user&#x27;s activated countries
    # @param countries json encoded string representing countries to activate
    # @param categories json encoded string representing categories ID to activate
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def user_countries_change_get_with_http_info(countries, categories, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_countries_change_get ...'
      end
      # verify the required parameter 'countries' is set
      if @api_client.config.client_side_validation && countries.nil?
        fail ArgumentError, "Missing the required parameter 'countries' when calling UserApi.user_countries_change_get"
      end
      # verify the required parameter 'categories' is set
      if @api_client.config.client_side_validation && categories.nil?
        fail ArgumentError, "Missing the required parameter 'categories' when calling UserApi.user_countries_change_get"
      end
      # resource path
      local_var_path = '/user_countries_change'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'countries'] = countries
      query_params[:'categories'] = categories

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_countries_change_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Change user customer id. This function is system reserved
    # @param custid new customer id for user
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def user_custid_change_get(custid, opts = {})
      data, _status_code, _headers = user_custid_change_get_with_http_info(custid, opts)
      data
    end

    # Change user customer id. This function is system reserved
    # @param custid new customer id for user
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def user_custid_change_get_with_http_info(custid, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_custid_change_get ...'
      end
      # verify the required parameter 'custid' is set
      if @api_client.config.client_side_validation && custid.nil?
        fail ArgumentError, "Missing the required parameter 'custid' when calling UserApi.user_custid_change_get"
      end
      # resource path
      local_var_path = '/user_custid_change'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'custid'] = custid

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_custid_change_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Permanently delete the user
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def user_delete_get(opts = {})
      data, _status_code, _headers = user_delete_get_with_http_info(opts)
      data
    end

    # Permanently delete the user
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def user_delete_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_delete_get ...'
      end
      # resource path
      local_var_path = '/user_delete'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_delete_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Change user details
    # @param email new email address for user
    # @param fname new firstname for user
    # @param lname new lastname for user
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def user_details_change_get(email, fname, lname, opts = {})
      data, _status_code, _headers = user_details_change_get_with_http_info(email, fname, lname, opts)
      data
    end

    # Change user details
    # @param email new email address for user
    # @param fname new firstname for user
    # @param lname new lastname for user
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def user_details_change_get_with_http_info(email, fname, lname, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_details_change_get ...'
      end
      # verify the required parameter 'email' is set
      if @api_client.config.client_side_validation && email.nil?
        fail ArgumentError, "Missing the required parameter 'email' when calling UserApi.user_details_change_get"
      end
      # verify the required parameter 'fname' is set
      if @api_client.config.client_side_validation && fname.nil?
        fail ArgumentError, "Missing the required parameter 'fname' when calling UserApi.user_details_change_get"
      end
      # verify the required parameter 'lname' is set
      if @api_client.config.client_side_validation && lname.nil?
        fail ArgumentError, "Missing the required parameter 'lname' when calling UserApi.user_details_change_get"
      end
      # resource path
      local_var_path = '/user_details_change'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'email'] = email
      query_params[:'fname'] = fname
      query_params[:'lname'] = lname

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_details_change_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Login user with his credentials
    # @param email email address for user
    # @param password password for user
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot;
    # @return [Array<UserInfo>]
    def user_login_get(email, password, opts = {})
      data, _status_code, _headers = user_login_get_with_http_info(email, password, opts)
      data
    end

    # Login user with his credentials
    # @param email email address for user
    # @param password password for user
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot;
    # @return [Array<(Array<UserInfo>, Integer, Hash)>] Array<UserInfo> data, response status code and response headers
    def user_login_get_with_http_info(email, password, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_login_get ...'
      end
      # verify the required parameter 'email' is set
      if @api_client.config.client_side_validation && email.nil?
        fail ArgumentError, "Missing the required parameter 'email' when calling UserApi.user_login_get"
      end
      # verify the required parameter 'password' is set
      if @api_client.config.client_side_validation && password.nil?
        fail ArgumentError, "Missing the required parameter 'password' when calling UserApi.user_login_get"
      end
      # resource path
      local_var_path = '/user_login'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'email'] = email
      query_params[:'password'] = password
      query_params[:'pin'] = opts[:'pin'] if !opts[:'pin'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<UserInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_login_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get messages for user
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :message ID of the requested message. 0 to get the full message list
    # @return [Array<Message>]
    def user_messages_get(opts = {})
      data, _status_code, _headers = user_messages_get_with_http_info(opts)
      data
    end

    # Get messages for user
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :message ID of the requested message. 0 to get the full message list
    # @return [Array<(Array<Message>, Integer, Hash)>] Array<Message> data, response status code and response headers
    def user_messages_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_messages_get ...'
      end
      # resource path
      local_var_path = '/user_messages'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'message'] = opts[:'message'] if !opts[:'message'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<Message>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_messages_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Change user password
    # @param email email address for user
    # @param password current password for user
    # @param newpassword new password to set up for user
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def user_password_change_get(email, password, newpassword, opts = {})
      data, _status_code, _headers = user_password_change_get_with_http_info(email, password, newpassword, opts)
      data
    end

    # Change user password
    # @param email email address for user
    # @param password current password for user
    # @param newpassword new password to set up for user
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def user_password_change_get_with_http_info(email, password, newpassword, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_password_change_get ...'
      end
      # verify the required parameter 'email' is set
      if @api_client.config.client_side_validation && email.nil?
        fail ArgumentError, "Missing the required parameter 'email' when calling UserApi.user_password_change_get"
      end
      # verify the required parameter 'password' is set
      if @api_client.config.client_side_validation && password.nil?
        fail ArgumentError, "Missing the required parameter 'password' when calling UserApi.user_password_change_get"
      end
      # verify the required parameter 'newpassword' is set
      if @api_client.config.client_side_validation && newpassword.nil?
        fail ArgumentError, "Missing the required parameter 'newpassword' when calling UserApi.user_password_change_get"
      end
      # resource path
      local_var_path = '/user_password_change'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'email'] = email
      query_params[:'password'] = password
      query_params[:'newpassword'] = newpassword

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_password_change_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Reset user password
    # @param email email address for user
    # @param [Hash] opts the optional parameters
    # @return [Array<TransactionInfo>]
    def user_password_reset_get(email, opts = {})
      data, _status_code, _headers = user_password_reset_get_with_http_info(email, opts)
      data
    end

    # Reset user password
    # @param email email address for user
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TransactionInfo>, Integer, Hash)>] Array<TransactionInfo> data, response status code and response headers
    def user_password_reset_get_with_http_info(email, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_password_reset_get ...'
      end
      # verify the required parameter 'email' is set
      if @api_client.config.client_side_validation && email.nil?
        fail ArgumentError, "Missing the required parameter 'email' when calling UserApi.user_password_reset_get"
      end
      # resource path
      local_var_path = '/user_password_reset'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'email'] = email

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<TransactionInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_password_reset_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Refresh user rights with his Customer ID. This function is system reserved
    # @param custid Customer ID for the user
    # @param [Hash] opts the optional parameters
    # @return [Array<UserInfo>]
    def user_refresh_subscription_get(custid, opts = {})
      data, _status_code, _headers = user_refresh_subscription_get_with_http_info(custid, opts)
      data
    end

    # Refresh user rights with his Customer ID. This function is system reserved
    # @param custid Customer ID for the user
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<UserInfo>, Integer, Hash)>] Array<UserInfo> data, response status code and response headers
    def user_refresh_subscription_get_with_http_info(custid, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_refresh_subscription_get ...'
      end
      # verify the required parameter 'custid' is set
      if @api_client.config.client_side_validation && custid.nil?
        fail ArgumentError, "Missing the required parameter 'custid' when calling UserApi.user_refresh_subscription_get"
      end
      # resource path
      local_var_path = '/user_refresh_subscription'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'custid'] = custid

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<UserInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_refresh_subscription_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Login user with his credentials
    # @param email email address for user
    # @param password password for user
    # @param fname new firstname for user
    # @param lname new lastname for user
    # @param [Hash] opts the optional parameters
    # @option opts [String] :referrer referrer for this user. should be urlencoded
    # @return [Array<UserInfo>]
    def user_register_get(email, password, fname, lname, opts = {})
      data, _status_code, _headers = user_register_get_with_http_info(email, password, fname, lname, opts)
      data
    end

    # Login user with his credentials
    # @param email email address for user
    # @param password password for user
    # @param fname new firstname for user
    # @param lname new lastname for user
    # @param [Hash] opts the optional parameters
    # @option opts [String] :referrer referrer for this user. should be urlencoded
    # @return [Array<(Array<UserInfo>, Integer, Hash)>] Array<UserInfo> data, response status code and response headers
    def user_register_get_with_http_info(email, password, fname, lname, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserApi.user_register_get ...'
      end
      # verify the required parameter 'email' is set
      if @api_client.config.client_side_validation && email.nil?
        fail ArgumentError, "Missing the required parameter 'email' when calling UserApi.user_register_get"
      end
      # verify the required parameter 'password' is set
      if @api_client.config.client_side_validation && password.nil?
        fail ArgumentError, "Missing the required parameter 'password' when calling UserApi.user_register_get"
      end
      # verify the required parameter 'fname' is set
      if @api_client.config.client_side_validation && fname.nil?
        fail ArgumentError, "Missing the required parameter 'fname' when calling UserApi.user_register_get"
      end
      # verify the required parameter 'lname' is set
      if @api_client.config.client_side_validation && lname.nil?
        fail ArgumentError, "Missing the required parameter 'lname' when calling UserApi.user_register_get"
      end
      # resource path
      local_var_path = '/user_register'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'email'] = email
      query_params[:'password'] = password
      query_params[:'fname'] = fname
      query_params[:'lname'] = lname
      query_params[:'referrer'] = opts[:'referrer'] if !opts[:'referrer'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<UserInfo>' 

      auth_names = opts[:auth_names] || ['bearerAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserApi#user_register_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
