=begin
#DiscoverSnoop

#API for DiscoverSnoop Service

OpenAPI spec version: 0.9.240913

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.62
=end

require 'spec_helper'
require 'json'

# Unit tests for SwaggerClient::HistoricalApi
# Automatically generated by swagger-codegen (github.com/swagger-api/swagger-codegen)
# Please update as you see appropriate
describe 'HistoricalApi' do
  before do
    # run before each test
    @instance = SwaggerClient::HistoricalApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of HistoricalApi' do
    it 'should create an instance of HistoricalApi' do
      expect(@instance).to be_instance_of(SwaggerClient::HistoricalApi)
    end
  end

  # unit tests for categories_get
  # Get historical stats for categories
  # @param country ISO_3166 country code in 2 letters
  # @param [Hash] opts the optional parameters
  # @option opts [String] :subcountry state code
  # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :keyword_filter Filter answers to cateogry names containing a particular keyword
  # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more)
  # @option opts [Integer] :offset Get paginated results from X offset
  # @return [Array<Categories>]
  describe 'categories_get test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for category_get
  # Get history for category ID
  # @param id category id
  # @param country ISO_3166 country code in 2 letters
  # @param [Hash] opts the optional parameters
  # @option opts [String] :subcountry state code
  # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @return [Array<Category>]
  describe 'category_get test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for domain_get
  # Get history for domain name
  # @param domain domain name (no subdomain allowed)
  # @param country ISO_3166 country code in 2 letters
  # @param [Hash] opts the optional parameters
  # @option opts [String] :subcountry state code
  # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @return [Array<Domain>]
  describe 'domain_get test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for domains_get
  # Get historical stats for domains
  # @param country ISO_3166 country code in 2 letters
  # @param [Hash] opts the optional parameters
  # @option opts [String] :subcountry state code
  # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :url_filter Filter answers to domains including a specified string
  # @option opts [Integer] :lines Get X results (max in one request is 10K please use offset paginated results if you need more)
  # @option opts [Integer] :offset Get paginated results from X offset
  # @return [Array<Domains>]
  describe 'domains_get test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for page_get
  # Get page history for URL
  # @param url Fully qualified page url. URL needs to be URL encoded
  # @param country ISO_3166 country code in 2 letters
  # @param [Hash] opts the optional parameters
  # @option opts [String] :subcountry state code
  # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
  # @return [Array<Page>]
  describe 'page_get test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for pages_get
  # Get historical stats for pages
  # @param preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone
  # @param [Hash] opts the optional parameters
  # @option opts [String] :from_date Datas from YYYY-MM-DD (if not provided, last 30 days)
  # @option opts [String] :to_date Datas to YYYY-MM-DD (if not provided, last 30 days)
  # @option opts [String] :country ISO_3166 country code in 2 letters (if not provided  worldwide)
  # @option opts [String] :subcountry state code
  # @option opts [String] :domain_filter Filter answers to pages of a designated domain name
  # @option opts [String] :url_filter Filter answers to pages URL including a specified string
  # @option opts [Integer] :category_filter Filter answers to a specific page category
  # @option opts [String] :keyword_filter Filter answers to pages titles containing a particular keyword
  # @option opts [Integer] :lines Get X results (max in one request is 50 please use offset paginated results if you need more)
  # @option opts [Integer] :offset Get paginated results from X offset
  # @return [Array<Pages>]
  describe 'pages_get test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
